//Scale your vehicles with a wand!
//Made by Cruxeis

function serverCmdscaleSize(%c, %a0, %a1, %a2)
{
	if(%c.isSuperAdmin)
	{
		for(%i = 0; %i < 3; %i++)
			%m = %m SPC %a[%i];
    messageAll('', "\c6The scaleSize for the scaleWand is now \c2" @ %m);
	$Pref::Server::ScaleSize = %m;
	}
	else 
		return messageClient(%c, '', "\c6You must be \c2Super Admin \c6to use this command.");
}

datablock particleData(scaleWandExplosionParticle)
{
	dragCoefficient = 2;
	gravityCoefficient = 0;
	inheritedVelFactor = 0;
	constantAcceleration = 0.0;
	lifetimeMS = 200;
	lifetimeVarianceMS = 0;
	textureName = "base/data/particles/cloud";
	spinSpeed = 10.0;
	spinRandomMin = 0.0;
	spinRandomMax = 0.0;
	colors[0] = "1 1 1 0.9";
	colors[1] = "0.6 1 0.6 1";
	colors[2] = "0.5 1 0.5 1";
	sizes[0] = 0.25;
	sizes[1] = 0.5;
	sizes[2] = 1;

	useInvAlpha = false;
};

datablock particleEmitterData(scaleWandExplosionEmitter)
{
	lifeTimeMS = 3000;
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 10;
	velocityVariance = 0.0;
	ejectionOffset	= 0.0;
	thetaMin = 80;
	thetaMax = 100;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvance = false;
	particles = scaleWandExplosionParticle;
};

datablock explosionData(scaleWandExplosion)
{
	camShakeDuration = 0.5;
	camShakeFreq = "2 2 2";
	emitter[0] = "scaleWandExplosionEmitter";
	faceViewer = 1;
	lifetimeMS = 180;
	lightEndRadius = 0.5;
	lightStartColor = "0 0 0 0";
	lightStartRadius = 2.5;
	shakeCamera = 0;
	soundProfile = "wandHitSound";
};

datablock particleData(scaleWandParticleA)
{
	colors[0] = "1 1 1 0.9";
	colors[1] = "1 1 1 0.9";
	colors[2] = "1 1 1 0.9";
	colors[3] = "1 1 1 0.9";
	gravityCoefficient = 0;
	lifetimeMS = 100;
	lifetimeVarianceMS = 0;
	sizes[0] = 0.1;
	sizes[1] = 0.1;
	sizes[2] = 0.15;
	spinRandomMax = 90;
	spinRandomMin = -90;
	textureName = "base/data/particles/ring";
	times[1] = 0.2;
	times[2] = 1;
};

datablock particleEmitterData(scaleWandEmitterA)
{
	ejectionOffset = 0.09;
	ejectionPeriodMS = 5;
	ejectionVelocity = 0.3;
	particles = "scaleWandParticleA";
	periodVarianceMS = 0;
	thetaMax = 180;
	velocityVariance = 0;
};

datablock particleData(scaleWandParticleB)
{
	colors[0] = "1 1 1 0.9";
	colors[1] = "1 1 1 0.9";
	colors[2] = "1 1 1 0.9";
	colors[3] = "1 1 1 0.9";
	gravityCoefficient = -0.2;
	inheritedVelFactor = 0.5;
	lifetimeMS = 200;
	lifetimeVarianceMS = 0;
	sizes[0] = 0.1;
	sizes[1] = 0.1;
	sizes[2] = 0.15;
	spinRandomMax = 90;
	spinRandomMin = -90;
	textureName = "base/data/particles/ring";
	times[1] = 0.8;
	times[2] = 1;
};

datablock particleEmitterData(scaleWandEmitterB)
{
	ejectionOffset	= 0.1;
	ejectionPeriodMS = 2;
	ejectionVelocity = 0.5;
	particles = "scaleWandParticleB";
	periodVarianceMS = 0;
	thetaMax = 180;
	velocityVariance = 0;
};

datablock projectileData(scaleWandProjectile)
{
	bounceElasticity = 0;
	bounceFriction	= 0;
	explodeOnDeath	= 1;
	explosion = "scaleWandExplosion";
	fadeDelay = 2;
	gravityMod = 0;
	lifetime = 0;
	mask = $TypeMasks::All;
	range = 50;
};

datablock itemData(scaleWandItem)
{
	cameraMaxDist	= 0.1;
	canDrop = 1;
	category = "Weapon";
	className = "Tool";
	colorShiftColor = "0.4 1 0 1";
	density	= 0.2;
	doColorShift = 1;
	elasticity = 0.2;
	emap = 1;
	friction = 0.6;
	iconName = "base/client/ui/itemIcons/wand";
	image = "scaleWandImage";
	shapeFile = "base/data/shapes/wand.dts";
	uiName = "Respawn Wand";
};

datablock shapeBaseImageData(scaleWandImage)
{
	ammo = " ";
	armReady = "1";
	className = "WeaponImage";
	colorShiftColor	= scaleWandItem.colorShiftColor;
	correctMuzzleVector = "0";
	doColorShift = "1";
	doRetraction = "0";
	eyeOffset = "0.7 1.2 -0.25";
	item = "scaleWandItem";
	melee = "1";
	projectile = "scaleWandProjectile";
	projectileType = "Projectile";
	shapeFile = "base/data/shapes/wand.dts";
	showBricks = "1";
	stateAllowImageChange[2]        = "0";
	stateEmitter[1]                 = "scaleWandEmitterA";
	stateEmitter[3]                 = "scaleWandEmitterB";
	stateEmitterNode[1]             = "muzzlePoint";
	stateEmitterNode[3]             = "blah";
	stateEmitterTime[1]             = "0.15";
	stateEmitterTime[3]             = "0.4";
	stateFire[3]                    = "1";
	stateName[0]                    = "Activate";
	stateName[1]                    = "Ready";
	stateName[2]                    = "PreFire";
	stateName[3]                    = "Fire";
	stateName[4]                    = "CheckFire";
	stateName[5]                    = "StopFire";
	stateScript[2]                  = "onPreFire";
	stateScript[3]                  = "onFire";
	stateScript[5]                  = "onCeaseFire";
	stateSequence[3]                = "fire";
	stateSequence[5]                = "StopFire";
	stateTimeoutValue[2]            = "0.1";
	stateTimeoutValue[3]            = "0.2";
	stateTimeoutValue[5]            = "0.2";
	stateTransitionOnTimeout[0]     = "ready";
	stateTransitionOnTimeout[1]     = "ready";
	stateTransitionOnTimeout[2]     = "fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTransitionOnTimeout[5]     = "ready";
	stateTransitionOnTriggerDown[1] = "PreFire";
	stateTransitionOnTriggerDown[4] = "fire";
	stateTransitionOnTriggerUp[4]   = "StopFire";
};

function serverCmdscaleWand(%client)
{
	if(isObject(%player = %client.player) && %client.isSuperAdmin)
	{
		%player.updateArm("scaleWandImage");
		%player.mountImage("scaleWandImage", 0);
	}
	else
		messageClient(%client, '', "\c6You do not have permission to use the \c2scaleation Wand\c6.");
}

function scaleWandItem::onPickup(%this, %obj, %player)
{
	if(%player.client.isSuperAdmin)
		Parent::onPickup(%this, %obj, %player);
	else
		messageClient(%player.client, '', "\c6You do not have permission to use the \c2scaleation Wand\c6.");
}

function scaleWandImage::onFire(%this, %obj, %slot)
{
	if(!isObject(%obj.client)) return;
	%start = %obj.getEyePoint();
	%end = vectorScale(%obj.getEyeVector(), %this.projectile.range);
	%rayCast = containerRayCast(%start, vectorAdd(%start, %end), %this.projectile.mask, %obj);
	%target = getWord(%rayCast, 0);
	if(!isObject(%target)) return;
	%client = %obj.client;
	%pos = posFromRaycast(%raycast);
	%projectile = new projectile()
	{
		dataBlock = %this.projectile;
		initialVelocity = %obj.getEyeVector();
		initialPosition = %pos;
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %client;
	};
	missionCleanup.add(%projectile);
	if(%target.getType() & $TypeMasks::VehicleObjectType)
	{
		%target.setScale($Pref::Server::ScaleSize);
	}
}

function scaleWandImage::onPreFire(%this, %obj, %slot)
{
	%obj.playThread(2, "armAttack");
}

function scaleWandImage::onCeaseFire(%this, %obj, %slot)
{
	%obj.playThread(2, "root");
}